//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.util.*;
import java.io.*; 

public class GD {
  Vector m,w,wm;
  boolean error;
  Random rnd=new Random();
  public GD() {
    error = false;
    m = new Vector ((int)30,(int)3);//matriz de ejemplares
    wm = new Vector ((int)30,(int)3);//matriz de pesos
    w = new Vector ((int)30,(int)3);//vector de pesos
    read ("nand.txt",m);
    GradDesc(m,w,(float)0.05);
    show(w,"NAND");
    wm.addElement(w);
    w = new Vector ((int)30,(int)3);//vector de pesos
    read ("or.txt",m);
    GradDesc(m,w,(float)0.05);
    show(w,"OR");
    wm.addElement(w);
    w = new Vector ((int)30,(int)3);//vector de pesos
    read ("and.txt",m);
    GradDesc(m,w,(float)0.05);
    show(w,"AND");
    wm.addElement(w);
    write("xor.txt",wm);
  }

  public double norma(Vector v){
    float n=0;
    Float num;
    if (v==null){
      return Float.MAX_VALUE;
    }
    for (int i=0;i<v.size();i++){
      num=(Float)v.elementAt(i);
      n+=Math.pow(num.floatValue(),2);
    }
    return Math.sqrt(n);
  }

  public void GradDesc(Vector ejem, Vector w,float eta){
    Vector v,dw=null;
    Float num,x,wi,dwi,td;
    double umbral=0.00001,od;
    int size, cyc=0;
    v=(Vector)ejem.elementAt(0);
    size=v.size();//size of weight vector
    for (int i=0;i<size;i++){
      num=new Float(((rnd.nextFloat()*2)-1));
      w.addElement(num);
    }
    while((norma(dw)>umbral)&&(cyc<1000)){
      cyc++;
      dw = new Vector ((int)30,(int)3);
      for (int i=0;i<size;i++){
        num=new Float(0);
        dw.addElement(num);        
      }
      for (int i=0;i<ejem.size();i++){
        v=(Vector)ejem.elementAt(i);
        td=(Float)v.lastElement();
        od=0;
        for(int j=0;j<size;j++){
          if (j==0) 
            x=new Float(1);
          else
            x=(Float)v.elementAt(j-1);
          wi=(Float)w.elementAt(j);
          od+=x.floatValue()*wi.floatValue();
        }
        for(int j=0;j<size;j++){
          if (j==0) 
            x=new Float(1);
          else
            x=(Float)v.elementAt(j-1);
          dwi=(Float)dw.elementAt(j);
          num=new Float(dwi.floatValue()+eta*(td.floatValue()-od)*x.floatValue());
          dw.setElementAt(num,j);
        }
      }
      for (int i=0;i<size;i++){
        dwi=(Float)dw.elementAt(i);
        wi=(Float)w.elementAt(i);
        w.setElementAt(new Float(dwi.floatValue()+wi.floatValue()),i);
      }
    }
/*System.out.println(cyc);
System.out.println(norma(dw));
show(dw,"wd");*/
  }

  public void read(String file, Vector m){
    Vector v;
    char ch = '';
    String str = "";
    Float num;
    FileInputStream istream = null ;
    try { //read from file
      istream = new FileInputStream(file);
      while (ch != '|') {
        ch = '';
        v = new Vector ((int)30,(int)3);
        while ((ch != '\n')&&(ch != '|')) {
          str = "";
          ch = (char)istream.read();
          while ((ch != ' ')&&(ch != '\n')&&(ch != '|')) { //read number
            str+= ch;
            ch = (char)istream.read();
          }
          if (ch != '|') {
            //System.out.println(str); 
            num = new Float(str);
            v.addElement(num);//add number
          }
        }
        m.addElement(v);
      }
      istream.close();
    } catch(IOException ioe) {
      System.out.println(ioe.getMessage());
    }
  }
  
  public void write(String file, Vector z){
    Vector v;
    Float num;
    String str;
    FileOutputStream ostream = null ;
    try { //write to file
      ostream = new FileOutputStream(file);
      for (int i = 0;i < z.size();i++) {
        v = (Vector)z.elementAt(i);
        //System.out.println(cnt); 
        for (int j = 0;j < (v.size()-1);j++) {
          num = (Float)v.elementAt(j);
          str = num.toString();
          ostream.write(str.getBytes());
          ostream.write(' '); 
        }
        num = (Float)v.lastElement();
        str = num.toString();
        ostream.write(str.getBytes());
        ostream.write('\n'); 
      }
      ostream.close();
    } catch(IOException ioe) {
      System.out.println(ioe.getMessage());
    }
  }

  void show(Vector v,String str) {
    int i;
    Float num;
    System.out.print(str+": ");
    for (i = 0;i < v.size();i++) {
      num=(Float)v.elementAt(i);
      System.out.print(num.toString()+" ");
    }
    System.out.println("");
  }
  
  public static void main(String[] args) {
    GD gd = new GD();
  }
}