Program TribonacciSounds;                {Carlos Gershenson 17-18/feb/2001}
                                         {carlos@jlagunez.iquimica.unam.mx}
Uses
	crt;
Var
     s:array[0..10000] of real;
     i:integer;
     n,l,Code:integer;
     a,b,c,x0,x1,x2,m:real;

function dmod (a,b:real):real;
begin
     if a>=0 then
       dmod:=(Trunc(a*1000000) mod Trunc(b*1000000))/1000000
     else
       dmod:=-(Trunc(-a*1000000) mod Trunc(b*1000000))/1000000;
end;

Begin
     clrscr;
     textcolor(9);
     writeln('Welcome to the Generalized-Tribonacci sound generator');
     writeln('Copyright Gershenson Technologies 2001');
     writeln('Usage: tribsnd a b c x0 x1 x2 n m l');
     writeln('for iterating n times (n<10000) the Generalized-Tribonacci formula:');
     writeln('      /x0 if x=0');
     writeln('GT(x)=|x1 if x=1');
     writeln('      |x2 if x=2');
     writeln('      \a*GT(x-3)+b*GT(x-2)+c*GT(x-1) if x>2');
     writeln('');
     writeln('We bound GT to the interval +-m');
     writeln('if l=0, then there is a uniform length of the notes');
     writeln('if l=1, then there is an atangencial length of the notes');
     writeln('');
     writeln('e.g.: tribsnd 1 -1.1 1 1 1 6 100 9.42477 0');
     writeln('');

     Val(ParamStr(1), a, Code);
     if code <> 0 then
       Writeln('ERROR: a should be a real number');
     Val(ParamStr(2), b, Code);
     if code <> 0 then
       Writeln('ERROR: b should be a real number');
     Val(ParamStr(3), c, Code);
     if code <> 0 then
       Writeln('ERROR: c should be a real number');
     Val(ParamStr(4), x0, Code);
     if code <> 0 then
       Writeln('ERROR: x0 should be a real number');
     Val(ParamStr(5), x1, Code);
     if code <> 0 then
       Writeln('ERROR: x1 should be a real number');
     Val(ParamStr(6), x2, Code);
     if code <> 0 then
       Writeln('ERROR: x2 should be a real number');
     Val(ParamStr(7), n, Code);
     if ((code <> 0) or (n<0) or (n>10000)) then
       Writeln('ERROR: n should be a positive integer < 10000');
     Val(ParamStr(8), m, Code);
     if code <> 0 then
       Writeln('ERROR: m should be a real number');
     Val(ParamStr(9), l, Code);
     if code <> 0 then
       Writeln('ERROR: l should be an integer');

     s[0]:=x0;
     s[1]:=x1;
     s[2]:=x2;
     for i:=3 to n do
     begin
       s[i]:=dmod((a*s[i-3]+b*s[i-2]+c*s[i-1]),m);
       {writeln(s[i]);}
     end;
     if l=0 then
       {uniform length of notes}
       for i:=0 to n do
       begin
         Sound(520+Trunc(s[i]*50));
         Delay(150);
         NoSound;
       end
     else
       {atangencial length of notes}
       for i:=0 to n-1 do
       begin
         Sound(520+Trunc(s[i]*50));
         Delay(Trunc(300-((250*ArcTan(s[i]+s[i+1]))/(pi/2))));
         NoSound;
       end;

End.
